; Include file for use in EPL programs using EPIC.VxD on Win95/98
; ===============================================================

; Macros for Pigeon Hole access

; *******************************************
; N.B. Some of these macros won't work with
; EPIC firmware versions earlier than
; X118d2sa dated 6 JAN 98!
; *******************************************

; makedec16
; ---------
; This is needed to make a binary 16 bit value
; from two 'decimal' bytes. i.e. 100*hi + lo.
; The result is useful for "SetBcdPov" calls.
; *******************************************
#macro makedec16(wordv, hi8, lo8)
       pushv8(hi8)
       pushc(100)
       exec(90)        ; mult by 100
       pushv8(lo8)
       exec(74)        ; add two together
       popv16(wordv)
#endmac

; getPH8
; ------
; This copies a selected Pigeon Hole byte
; into an 8-bit variable. The second param
; is a 16-bit constant with PH number in bits
; 0-7 (the low byte), and the byte number
; required (0-3) in bits 8-15 (the high byte)
; *******************************************
#macro getPH8(bytev, phnum)
        pushc(phnum)
        exec(67)
        popv8(bytev)
#endmac


; getPH16
; -------
; This copies a selected Pigeon Hole word
; into a 16-bit variable. The second param
; is a 16-bit constant with PH number in bits
; 0-7 (the low byte), and the first byte number
; required (0-2) in bits 8-15 (the high byte)
; *******************************************

#macro getPH16(wordv, phnum)
 pushc(phnum)
 exec(68)
 popv16(wordv)
#endmac

; *******************************************
; N.B. Use this macro for enque16's with
; 16-bit variables (i.e. the SetBcdPov's)
; if using an EPL.EXE prior to 15 JAN 98
; (version 13.9a), otherwise they'll
; compile okay, but not work!
; *******************************************

;#macro enque16(key1,key2)
;       pushc(key1)
;       pushc(key2)
;       exec(96)
;#endmac
; ******************************************************************************

; Definition of the enque16 event codes:

;============================
; Button controls

#define BtnOn           0x001
#define BtnOff          0x002
#define BtnPulse        0x003
#define BtnRepeat       0x004
#define BtnClear        0x005
#define BtnToggle	0x006

#define BtnAllClear     0x010
#define BtnTogether     0x011

#define BtnSetDelay1    0x020
#define BtnSetRepeat1   0x021
#define BtnSetDelay2    0x022
#define BtnSetRepeat2   0x023

#define BtnSetBuffer    0x024

;============================
; "Soft" joystick axes

; Set directly stores given value for axis:

#define SetU0           0x130
#define SetV0           0x131

#define SetU1           0x132
#define SetV1           0x133

#define SetU2           0x134
#define SetV2           0x135

#define SetU3           0x136
#define SetV3           0x137

#define SetX4           0x100
#define SetY4           0x101
#define SetZ4           0x103
#define SetR4           0x102
#define SetU4           0x138
#define SetV4           0x139

#define SetX5           0x104
#define SetY5           0x105
#define SetZ5           0x107
#define SetR5           0x106
#define SetU5           0x13a
#define SetV5           0x13b

#define SetX6           0x108
#define SetY6           0x109
#define SetZ6           0x10b
#define SetR6           0x10a
#define SetU6           0x13c
#define SetV6           0x13d

#define SetX7           0x10c
#define SetY7           0x10d
#define SetZ7           0x10f
#define SetR7           0x10e
#define SetU7           0x13e
#define SetV7           0x13f

#define SetX8           0x110
#define SetY8           0x111
#define SetZ8           0x113
#define SetR8           0x112
#define SetU8           0x140
#define SetV8           0x141

#define SetX9           0x114
#define SetY9           0x115
#define SetZ9           0x117
#define SetR9           0x116
#define SetU9           0x142
#define SetV9           0x143

#define SetX10          0x118
#define SetY10          0x119
#define SetZ10          0x11b
#define SetR10          0x11a
#define SetU10          0x144
#define SetV10          0x145

#define SetX11          0x11c
#define SetY11          0x11d
#define SetZ11          0x11f
#define SetR11          0x11e
#define SetU11          0x146
#define SetV11          0x147

#define SetX12          0x120
#define SetY12          0x121
#define SetZ12          0x123
#define SetR12          0x122
#define SetU12          0x148
#define SetV12          0x149

#define SetX13          0x124
#define SetY13          0x125
#define SetZ13          0x127
#define SetR13          0x126
#define SetU13          0x14a
#define SetV13          0x14b

#define SetX14          0x128
#define SetY14          0x129
#define SetZ14          0x12b
#define SetR14          0x12a
#define SetU14          0x14c
#define SetV14          0x14d

#define SetX15          0x12c
#define SetY15          0x12d
#define SetZ15          0x12f
#define SetR15          0x12e
#define SetU15          0x14e
#define SetV15          0x14f

; Inc adds given value to axis, subject to maximum:

#define IncU0           0x180
#define IncV0           0x181

#define IncU1           0x182
#define IncV1           0x183

#define IncU2           0x184
#define IncV2           0x185

#define IncU3           0x186
#define IncV3           0x187

#define IncX4           0x150
#define IncY4           0x151
#define IncZ4           0x153
#define IncR4           0x152
#define IncU4           0x188
#define IncV4           0x189

#define IncX5           0x154
#define IncY5           0x155
#define IncZ5           0x157
#define IncR5           0x156
#define IncU5           0x18a
#define IncV5           0x18b

#define IncX6           0x158
#define IncY6           0x159
#define IncZ6           0x15b
#define IncR6           0x15a
#define IncU6           0x18c
#define IncV6           0x18d

#define IncX7           0x15c
#define IncY7           0x15d
#define IncZ7           0x15f
#define IncR7           0x15e
#define IncU7           0x18e
#define IncV7           0x18f

#define IncX8           0x160
#define IncY8           0x161
#define IncZ8           0x163
#define IncR8           0x162
#define IncU8           0x190
#define IncV8           0x191

#define IncX9           0x164
#define IncY9           0x165
#define IncZ9           0x167
#define IncR9           0x166
#define IncU9           0x192
#define IncV9           0x193

#define IncX10          0x168
#define IncY10          0x169
#define IncZ10          0x16b
#define IncR10          0x16a
#define IncU10          0x194
#define IncV10          0x195

#define IncX11          0x16c
#define IncY11          0x16d
#define IncZ11          0x16f
#define IncR11          0x16e
#define IncU11          0x196
#define IncV11          0x197

#define IncX12          0x170
#define IncY12          0x171
#define IncZ12          0x173
#define IncR12          0x172
#define IncU12          0x198
#define IncV12          0x199

#define IncX13          0x174
#define IncY13          0x175
#define IncZ13          0x177
#define IncR13          0x176
#define IncU13          0x19a
#define IncV13          0x19b

#define IncX14          0x178
#define IncY14          0x179
#define IncZ14          0x17b
#define IncR14          0x17a
#define IncU14          0x19c
#define IncV14          0x19d

#define IncX15          0x17c
#define IncY15          0x17d
#define IncZ15          0x17f
#define IncR15          0x17e
#define IncU15          0x19e
#define IncV15          0x19f

; Dec subtracts given value from axis, subject to minimum:

#define DecU0           0x1d0
#define DecV0           0x1d1

#define DecU1           0x1d2
#define DecV1           0x1d3

#define DecU2           0x1d4
#define DecV2           0x1d5

#define DecU3           0x1d6
#define DecV3           0x1d7

#define DecX4           0x1a0
#define DecY4           0x1a1
#define DecZ4           0x1a3
#define DecR4           0x1a2
#define DecU4           0x1d8
#define DecV4           0x1d9

#define DecX5           0x1a4
#define DecY5           0x1a5
#define DecZ5           0x1a7
#define DecR5           0x1a6
#define DecU5           0x1da
#define DecV5           0x1db

#define DecX6           0x1a8
#define DecY6           0x1a9
#define DecZ6           0x1ab
#define DecR6           0x1aa
#define DecU6           0x1dc
#define DecV6           0x1dd

#define DecX7           0x1ac
#define DecY7           0x1ad
#define DecZ7           0x1af
#define DecR7           0x1ae
#define DecU7           0x1de
#define DecV7           0x1df

#define DecX8           0x1b0
#define DecY8           0x1b1
#define DecZ8           0x1b3
#define DecR8           0x1b2
#define DecU8           0x1e0
#define DecV8           0x1e1

#define DecX9           0x1b4
#define DecY9           0x1b5
#define DecZ9           0x1b7
#define DecR9           0x1b6
#define DecU9           0x1e2
#define DecV9           0x1e3

#define DecX10          0x1b8
#define DecY10          0x1b9
#define DecZ10          0x1bb
#define DecR10          0x1ba
#define DecU10          0x1e4
#define DecV10          0x1e5

#define DecX11          0x1bc
#define DecY11          0x1bd
#define DecZ11          0x1bf
#define DecR11          0x1be
#define DecU11          0x1e6
#define DecV11          0x1e7

#define DecX12          0x1c0
#define DecY12          0x1c1
#define DecZ12          0x1c3
#define DecR12          0x1c2
#define DecU12          0x1e8
#define DecV12          0x1e9

#define DecX13          0x1c4
#define DecY13          0x1c5
#define DecZ13          0x1c7
#define DecR13          0x1c6
#define DecU13          0x1ea
#define DecV13          0x1eb

#define DecX14          0x1c8
#define DecY14          0x1c9
#define DecZ14          0x1cb
#define DecR14          0x1ca
#define DecU14          0x1ec
#define DecV14          0x1ed

#define DecX15          0x1cc
#define DecY15          0x1cd
#define DecZ15          0x1cf
#define DecR15          0x1ce
#define DecU15          0x1ee
#define DecV15          0x1ef

; Calibration aids:

#define SetSAxesMin     0x1fd   ; Sets all soft axes to their current minima
#define SetSAxesMax     0x1fe   ; Sets all soft axes to their current maxima

; Restore all "soft" axes to default values
; i.e. all X, Y, R centred, all Z, U, V maximum

#define RestoreSAxes    0x1ff

; Soft axis configurations: min/centre/max

; SetMin directly stores given value as minimum for axis:

#define SetMinU0        0x230
#define SetMinV0        0x231

#define SetMinU1        0x232
#define SetMinV1        0x233

#define SetMinU2        0x234
#define SetMinV2        0x235

#define SetMinU3        0x236
#define SetMinV3        0x237

#define SetMinX4        0x200
#define SetMinY4        0x201
#define SetMinZ4        0x203
#define SetMinR4        0x202
#define SetMinU4        0x238
#define SetMinV4        0x239

#define SetMinX5        0x204
#define SetMinY5        0x205
#define SetMinZ5        0x207
#define SetMinR5        0x206
#define SetMinU5        0x23a
#define SetMinV5        0x23b

#define SetMinX6        0x208
#define SetMinY6        0x209
#define SetMinZ6        0x20b
#define SetMinR6        0x20a
#define SetMinU6        0x23c
#define SetMinV6        0x23d

#define SetMinX7        0x20c
#define SetMinY7        0x20d
#define SetMinZ7        0x20f
#define SetMinR7        0x20e
#define SetMinU7        0x23e
#define SetMinV7        0x23f

#define SetMinX8        0x210
#define SetMinY8        0x211
#define SetMinZ8        0x213
#define SetMinR8        0x212
#define SetMinU8        0x240
#define SetMinV8        0x241

#define SetMinX9        0x214
#define SetMinY9        0x215
#define SetMinZ9        0x217
#define SetMinR9        0x216
#define SetMinU9        0x242
#define SetMinV9        0x243

#define SetMinX10       0x218
#define SetMinY10       0x219
#define SetMinZ10       0x21b
#define SetMinR10       0x21a
#define SetMinU10       0x244
#define SetMinV10       0x245

#define SetMinX11       0x21c
#define SetMinY11       0x21d
#define SetMinZ11       0x21f
#define SetMinR11       0x21e
#define SetMinU11       0x246
#define SetMinV11       0x247

#define SetMinX12       0x220
#define SetMinY12       0x221
#define SetMinZ12       0x223
#define SetMinR12       0x222
#define SetMinU12       0x248
#define SetMinV12       0x249

#define SetMinX13       0x224
#define SetMinY13       0x225
#define SetMinZ13       0x227
#define SetMinR13       0x226
#define SetMinU13       0x24a
#define SetMinV13       0x24b

#define SetMinX14       0x228
#define SetMinY14       0x229
#define SetMinZ14       0x22b
#define SetMinR14       0x22a
#define SetMinU14       0x24c
#define SetMinV14       0x24d

#define SetMinX15       0x22c
#define SetMinY15       0x22d
#define SetMinZ15       0x22f
#define SetMinR15       0x22e
#define SetMinU15       0x24e
#define SetMinV15       0x24f

; SetCen sets centre value for given axis

#define SetCenU0        0x280
#define SetCenV0        0x281

#define SetCenU1        0x282
#define SetCenV1        0x283

#define SetCenU2        0x284
#define SetCenV2        0x285

#define SetCenU3        0x286
#define SetCenV3        0x287

#define SetCenX4        0x250
#define SetCenY4        0x251
#define SetCenZ4        0x253
#define SetCenR4        0x252
#define SetCenU4        0x288
#define SetCenV4        0x289

#define SetCenX5        0x254
#define SetCenY5        0x255
#define SetCenZ5        0x257
#define SetCenR5        0x256
#define SetCenU5        0x28a
#define SetCenV5        0x28b

#define SetCenX6        0x258
#define SetCenY6        0x259
#define SetCenZ6        0x25b
#define SetCenR6        0x25a
#define SetCenU6        0x28c
#define SetCenV6        0x28d

#define SetCenX7        0x25c
#define SetCenY7        0x25d
#define SetCenZ7        0x25f
#define SetCenR7        0x25e
#define SetCenU7        0x28e
#define SetCenV7        0x28f

#define SetCenX8        0x260
#define SetCenY8        0x261
#define SetCenZ8        0x263
#define SetCenR8        0x262
#define SetCenU8        0x290
#define SetCenV8        0x291

#define SetCenX9        0x264
#define SetCenY9        0x265
#define SetCenZ9        0x267
#define SetCenR9        0x266
#define SetCenU9        0x292
#define SetCenV9        0x293

#define SetCenX10       0x268
#define SetCenY10       0x269
#define SetCenZ10       0x26b
#define SetCenR10       0x26a
#define SetCenU10       0x294
#define SetCenV10       0x295

#define SetCenX11       0x26c
#define SetCenY11       0x26d
#define SetCenZ11       0x26f
#define SetCenR11       0x26e
#define SetCenU11       0x296
#define SetCenV11       0x297

#define SetCenX12       0x270
#define SetCenY12       0x271
#define SetCenZ12       0x273
#define SetCenR12       0x272
#define SetCenU12       0x298
#define SetCenV12       0x299

#define SetCenX13       0x274
#define SetCenY13       0x275
#define SetCenZ13       0x277
#define SetCenR13       0x276
#define SetCenU13       0x29a
#define SetCenV13       0x29b

#define SetCenX14       0x278
#define SetCenY14       0x279
#define SetCenZ14       0x27b
#define SetCenR14       0x27a
#define SetCenU14       0x29c
#define SetCenV14       0x29d

#define SetCenX15       0x27c
#define SetCenY15       0x27d
#define SetCenZ15       0x27f
#define SetCenR15       0x27e
#define SetCenU15       0x29e
#define SetCenV15       0x29f

; SetMax sets the maximum value for the given axis

#define SetMaxU0        0x2d0
#define SetMaxV0        0x2d1

#define SetMaxU1        0x2d2
#define SetMaxV1        0x2d3

#define SetMaxU2        0x2d4
#define SetMaxV2        0x2d5

#define SetMaxU3        0x2d6
#define SetMaxV3        0x2d7

#define SetMaxX4        0x2a0
#define SetMaxY4        0x2a1
#define SetMaxZ4        0x2a3
#define SetMaxR4        0x2a2
#define SetMaxU4        0x2d8
#define SetMaxV4        0x2d9

#define SetMaxX5        0x2a4
#define SetMaxY5        0x2a5
#define SetMaxZ5        0x2a7
#define SetMaxR5        0x2a6
#define SetMaxU5        0x2da
#define SetMaxV5        0x2db

#define SetMaxX6        0x2a8
#define SetMaxY6        0x2a9
#define SetMaxZ6        0x2ab
#define SetMaxR6        0x2aa
#define SetMaxU6        0x2dc
#define SetMaxV6        0x2dd

#define SetMaxX7        0x2ac
#define SetMaxY7        0x2ad
#define SetMaxZ7        0x2af
#define SetMaxR7        0x2ae
#define SetMaxU7        0x2de
#define SetMaxV7        0x2df

#define SetMaxX8        0x2b0
#define SetMaxY8        0x2b1
#define SetMaxZ8        0x2b3
#define SetMaxR8        0x2b2
#define SetMaxU8        0x2e0
#define SetMaxV8        0x2e1

#define SetMaxX9        0x2b4
#define SetMaxY9        0x2b5
#define SetMaxZ9        0x2b7
#define SetMaxR9        0x2b6
#define SetMaxU9        0x2e2
#define SetMaxV9        0x2e3

#define SetMaxX10       0x2b8
#define SetMaxY10       0x2b9
#define SetMaxZ10       0x2bb
#define SetMaxR10       0x2ba
#define SetMaxU10       0x2e4
#define SetMaxV10       0x2e5

#define SetMaxX11       0x2bc
#define SetMaxY11       0x2bd
#define SetMaxZ11       0x2bf
#define SetMaxR11       0x2be
#define SetMaxU11       0x2e6
#define SetMaxV11       0x2e7

#define SetMaxX12       0x2c0
#define SetMaxY12       0x2c1
#define SetMaxZ12       0x2c3
#define SetMaxR12       0x2c2
#define SetMaxU12       0x2e8
#define SetMaxV12       0x2e9

#define SetMaxX13       0x2c4
#define SetMaxY13       0x2c5
#define SetMaxZ13       0x2c7
#define SetMaxR13       0x2c6
#define SetMaxU13       0x2ea
#define SetMaxV13       0x2eb

#define SetMaxX14       0x2c8
#define SetMaxY14       0x2c9
#define SetMaxZ14       0x2cb
#define SetMaxR14       0x2ca
#define SetMaxU14       0x2ec
#define SetMaxV14       0x2ed

#define SetMaxX15       0x2cc
#define SetMaxY15       0x2cd
#define SetMaxZ15       0x2cf
#define SetMaxR15       0x2ce
#define SetMaxU15       0x2ee
#define SetMaxV15       0x2ef

; Restore all "soft" axes to default values
; and restore default min (1), max (255) and centre (128)
; values. This also removes "hard axis" scale and offsets,
; removes any axis mapping (see later), and enables all
; EPIC95 controlled Win95 axes.

#define ResetAllAxes      0x2ff

;============================
; Point Of View (POV) controls

; Set provides 360 degree settings

#define SetPov0         0x300
#define SetPov1         0x301
#define SetPov2         0x302
#define SetPov3         0x303
#define SetPov4         0x304
#define SetPov5         0x305
#define SetPov6         0x306
#define SetPov7         0x307
#define SetPov8         0x308
#define SetPov9         0x309
#define SetPov10        0x30a
#define SetPov11        0x30b
#define SetPov12        0x30c
#define SetPov13        0x30d
#define SetPov14        0x30e
#define SetPov15        0x30f

; IncPov increments selected POv by a number of degrees

#define IncPov0         0x310
#define IncPov1         0x311
#define IncPov2         0x312
#define IncPov3         0x313
#define IncPov4         0x314
#define IncPov5         0x315
#define IncPov6         0x316
#define IncPov7         0x317
#define IncPov8         0x318
#define IncPov9         0x319
#define IncPov10        0x31a
#define IncPov11        0x31b
#define IncPov12        0x31c
#define IncPov13        0x31d
#define IncPov14        0x31e
#define IncPov15        0x31f

; DecPov decrements selected POv by a number of degrees

#define DecPov0         0x320
#define DecPov1         0x321
#define DecPov2         0x322
#define DecPov3         0x323
#define DecPov4         0x324
#define DecPov5         0x325
#define DecPov6         0x326
#define DecPov7         0x327
#define DecPov8         0x328
#define DecPov9         0x329
#define DecPov10        0x32a
#define DecPov11        0x32b
#define DecPov12        0x32c
#define DecPov13        0x32d
#define DecPov14        0x32e
#define DecPov15        0x32f

; SetFine provides 36000 1/100th degree settings,
; or can be used to transfer any 16-bit value (0-65535)

#define SetFinePov0     0x330
#define SetFinePov1     0x331
#define SetFinePov2     0x332
#define SetFinePov3     0x333
#define SetFinePov4     0x334
#define SetFinePov5     0x335
#define SetFinePov6     0x336
#define SetFinePov7     0x337
#define SetFinePov8     0x338
#define SetFinePov9     0x339
#define SetFinePov10    0x33a
#define SetFinePov11    0x33b
#define SetFinePov12    0x33c
#define SetFinePov13    0x33d
#define SetFinePov14    0x33e
#define SetFinePov15    0x33f

; SetBcd is also used for 16-bit values, but the VxD
; converts the binary value to Decimal coding. The value
; needs to be in the range 0 - 9999 and is converted to
; a BCD (binary coded decimal) value 0x0000 - 0x9999 before
; delivering to the target program

#define SetBcdPov0     0x350
#define SetBcdPov1     0x351
#define SetBcdPov2     0x352
#define SetBcdPov3     0x353
#define SetBcdPov4     0x354
#define SetBcdPov5     0x355
#define SetBcdPov6     0x356
#define SetBcdPov7     0x357
#define SetBcdPov8     0x358
#define SetBcdPov9     0x359
#define SetBcdPov10    0x35a
#define SetBcdPov11    0x35b
#define SetBcdPov12    0x35c
#define SetBcdPov13    0x35d
#define SetBcdPov14    0x35e
#define SetBcdPov15    0x35f

; OffPov turns the POV off (no value supplied to application): 0ff = 0 here

#define OffPov0         0x340
#define OffPov1         0x341
#define OffPov2         0x342
#define OffPov3         0x343
#define OffPov4         0x344
#define OffPov5         0x345
#define OffPov6         0x346
#define OffPov7         0x347
#define OffPov8         0x348
#define OffPov9         0x349
#define OffPov10        0x34a
#define OffPov11        0x34b
#define OffPov12        0x34c
#define OffPov13        0x34d
#define OffPov14        0x34e
#define OffPov15        0x34f

; OffXPov turns the POV off (no value supplied to application): 0ff = -1 here

#define OffXPov0        0x360
#define OffXPov1        0x361
#define OffXPov2        0x362
#define OffXPov3        0x363
#define OffXPov4        0x364
#define OffXPov5        0x365
#define OffXPov6        0x366
#define OffXPov7        0x367
#define OffXPov8        0x368
#define OffXPov9        0x369
#define OffXPov10       0x36a
#define OffXPov11       0x36b
#define OffXPov12       0x36c
#define OffXPov13       0x36d
#define OffXPov14       0x36e
#define OffXPov15       0x36f

;============================
; Real analogue axis scale and offset
;
; Scale by 0 = no scaling, else acts as divisor
;
; N.B. EPIC outputs 0-15 are
;       0 = X0 (aileron)        4 = X1  8 = X2 12 = X3
;       1 = Y0 (elevator)       5 = Y1  9 = Y2 13 = Y3
;       2 = R0 (rudder)         6 = R1 10 = R2 14 = R3
;       3 = Z0 (throttle)       7 = Z1 11 = Z2 15 = Z3

#define ScaleX0         0x380
#define ScaleY0         0x381
#define ScaleZ0         0x383
#define ScaleR0         0x382

#define ScaleX1         0x384
#define ScaleY1         0x385
#define ScaleZ1         0x387
#define ScaleR1         0x386

#define ScaleX2         0x388
#define ScaleY2         0x389
#define ScaleZ2         0x38b
#define ScaleR2         0x38a

#define ScaleX3         0x38c
#define ScaleY3         0x38d
#define ScaleZ3         0x38f
#define ScaleR3         0x38e

; Offset by 0 = no offset, else increments AFTER scaling

#define OffsetX0        0x390
#define OffsetY0        0x391
#define OffsetZ0        0x393
#define OffsetR0        0x392

#define OffsetX1        0x394
#define OffsetY1        0x395
#define OffsetZ1        0x397
#define OffsetR1        0x396

#define OffsetX2        0x398
#define OffsetY2        0x399
#define OffsetZ2        0x39b
#define OffsetR2        0x39a

#define OffsetX3        0x39c
#define OffsetY3        0x39d
#define OffsetZ3        0x39f
#define OffsetR3        0x39e

; SetMin: constrains value AFTER scaling and offset 

#define SetMinX0        0x3a0
#define SetMinY0        0x3a1
#define SetMinZ0        0x3a3
#define SetMinR0        0x3a2

#define SetMinX1        0x3a4
#define SetMinY1        0x3a5
#define SetMinZ1        0x3a7
#define SetMinR1        0x3a6

#define SetMinX2        0x3a8
#define SetMinY2        0x3a9
#define SetMinZ2        0x3ab
#define SetMinR2        0x3aa

#define SetMinX3        0x3ac
#define SetMinY3        0x3ad
#define SetMinZ3        0x3af
#define SetMinR3        0x3ae

; SetMax: constrains value AFTER scaling and offset

#define SetMaxX0        0x3b0
#define SetMaxY0        0x3b1
#define SetMaxZ0        0x3b3
#define SetMaxR0        0x3b2

#define SetMaxX1        0x3b4
#define SetMaxY1        0x3b5
#define SetMaxZ1        0x3b7
#define SetMaxR1        0x3b6

#define SetMaxX2        0x3b8
#define SetMaxY2        0x3b9
#define SetMaxZ2        0x3bb
#define SetMaxR2        0x3ba

#define SetMaxX3        0x3bc
#define SetMaxY3        0x3bd
#define SetMaxZ3        0x3bf
#define SetMaxR3        0x3be

;============================
; Analogue axis mapping
;
; This set allows any axis (0-95) to be supplied
; through Win95 as any of the 96 axes it
; supports. Furthermore, the SAME axis can be 
; mapped to more than one Win95 axis.
;
; All other manipulations, (Min/Max/Scale/Offset)
; are performed AFTER this mapping has occurred.
; So the same original value can be manipulated
; on one win95 input but not on another, for
; instance.
;
; Use: Enque16(SetMapXX,n) where n = 0-95, the
; original axis.
;
; Values 0-15 refer, of course, to EPIC's real
; output axes. Values 16-95 can be used to remap
; soft axes, and even map a soft axis to a 'real'
; one. Values 16-63 refer to the X,Y,R,Z axes for
; joysticks 4-15, and 64-95 refer to U,V axes for
; joysticks 0-15, in order). Use value 96 to clear
; that mapping, or any value OVER 96 to disable
; the Win95 input axis (this freezes it at maximum
; value, as if disconnected).

#define SetMapX0        0x080
#define SetMapY0        0x081
#define SetMapZ0        0x083
#define SetMapR0        0x082

#define SetMapX1        0x084
#define SetMapY1        0x085
#define SetMapZ1        0x087
#define SetMapR1        0x086

#define SetMapX2        0x088
#define SetMapY2        0x089
#define SetMapZ2        0x08b
#define SetMapR2        0x08a

#define SetMapX3        0x08c
#define SetMapY3        0x08d
#define SetMapZ3        0x08f
#define SetMapR3        0x08e

#define SetMapX4        0x090
#define SetMapY4        0x091
#define SetMapZ4        0x093
#define SetMapR4        0x092

#define SetMapX5        0x094
#define SetMapY5        0x095
#define SetMapZ5        0x097
#define SetMapR5        0x096

#define SetMapX6        0x098
#define SetMapY6        0x099
#define SetMapZ6        0x09b
#define SetMapR6        0x09a

#define SetMapX7        0x09c
#define SetMapY7        0x09d
#define SetMapZ7        0x09f
#define SetMapR7        0x09e

#define SetMapX8        0x0a0
#define SetMapY8        0x0a1
#define SetMapZ8        0x0a3
#define SetMapR8        0x0a2

#define SetMapX9        0x0a4
#define SetMapY9        0x0a5
#define SetMapZ9        0x0a7
#define SetMapR9        0x0a6

#define SetMapX10       0x0a8
#define SetMapY10       0x0a9
#define SetMapZ10       0x0ab
#define SetMapR10       0x0aa

#define SetMapX11       0x0ac
#define SetMapY11       0x0ad
#define SetMapZ11       0x0af
#define SetMapR11       0x0ae

#define SetMapX12       0x0b0
#define SetMapY12       0x0b1
#define SetMapZ12       0x0b3
#define SetMapR12       0x0b2

#define SetMapX13       0x0b4
#define SetMapY13       0x0b5
#define SetMapZ13       0x0b7
#define SetMapR13       0x0b6

#define SetMapX14       0x0b8
#define SetMapY14       0x0b9
#define SetMapZ14       0x0bb
#define SetMapR14       0x0ba

#define SetMapX15       0x0bc
#define SetMapY15       0x0bd
#define SetMapZ15       0x0bf
#define SetMapR15       0x0be

#define SetMapU0        0x0c0
#define SetMapV0        0x0c1
#define SetMapU1        0x0c2
#define SetMapV1        0x0c3
#define SetMapU2        0x0c4
#define SetMapV2        0x0c5
#define SetMapU3        0x0c6
#define SetMapV3        0x0c7

#define SetMapU4        0x0c8
#define SetMapV4        0x0c9
#define SetMapU5        0x0ca
#define SetMapV5        0x0cb
#define SetMapU6        0x0cc
#define SetMapV6        0x0cd
#define SetMapU7        0x0ce
#define SetMapV7        0x0cf

#define SetMapU8        0x0d0
#define SetMapV8        0x0d1
#define SetMapU9        0x0d2
#define SetMapV9        0x0d3
#define SetMapU10       0x0d4
#define SetMapV10       0x0d5
#define SetMapU11       0x0d6
#define SetMapV11       0x0d7

#define SetMapU12       0x0d8
#define SetMapV12       0x0d9
#define SetMapU13       0x0da
#define SetMapV13       0x0db
#define SetMapU14       0x0dc
#define SetMapV14       0x0dd
#define SetMapU15       0x0de
#define SetMapV15       0x0df

;============================
; Reset real axes to no scale no offset, no min/max,
; and no mapping, with all Win95 EPIC95 controlled
; joysticks enabled.
; (Note this is also done by "ResetAllAxes", above)

#define ResetRealAxes   0x3ff

;============================
; Inter EPIC facilities (EPICs in separate PCs connected
; by LAN, with EpicServer and EicClient programs running)

; Parameter is 16-bit value stored in PH's bytes 2-3, and
; also decimalised in bytes 0 (remainder/100) and 1
; (quotient when /100). Note the latter is not defined
; when the number is outside the range 0-25599.

#define SendPH0		0x0ec	; Goes to PH96 in all Clients
#define SendPH1		0x0ed	; Goes to PH97 in all Clients
#define SendPH2		0x0ee	; Goes to PH98 in all Clients
#define SendPH3		0x0ef	; Goes to PH99 in all Clients

; No parameter (leave as 0) for QP sent to Clients:
#define SendQP0		0x0e0	; Sets QP190 in all Clients
#define SendQP1		0x0e1	; Sets QP191 in all Clients
#define SendQP2		0x0e2	; Sets QP192 in all Clients
#define SendQP3		0x0e3	; Sets QP193 in all Clients
#define SendQP4		0x0e4	; Sets QP194 in all Clients
#define SendQP5		0x0e5	; Sets QP195 in all Clients
#define SendQP6		0x0e6	; Sets QP196 in all Clients
#define SendQP7		0x0e7	; Sets QP197 in all Clients
#define SendQP8		0x0e8	; Sets QP198 in all Clients
#define SendQP9		0x0e9	; Sets QP199 in all Clients

;============================
; Mouse facilities

; NB, except for mouse button clicking, all the Mouse facilities
; require the utility EpicMous.EXE to be running!

#define MouseXScale     0x0f6   ; Stores screen width (X) for X coordinates
#define MouseYScale     0x0f7   ; Stores screen height (Y) for Y coordinates

; If these are initialised (say in :init) then all the X,Y mouse coordinates
; used in the MouseX and MouseY commands (below) are scaled
; appropriately IF the screen resolution set at the time is
; different to the size set here. The same applies to displayed/PH X,Y
; positions. (This latter feature can therefore be very useful in doing FS98
; panel design -- set the X,Y scale values to the *designed* size of the
; panel, so that the mouse positions are (relatively) correct).

#define MouseX          0x0f8   ; Stores X-coordinate for MouseBtn, below
#define MouseY          0x0f9   ; Stores Y-coordinate for MouseBtn, below

#define MouseBtn        0x0fa   ; Moves mouse to set (X,Y) and operates buttons

; To drive the Mouse through the VXD you need to first set
; the (X,Y) screen coordinate, using the MouseX and MouseY calls
; then use the MouseBtn calls to operate buttons. A single button
; click on the left button, (MouseBtn,12), is the most useful.
;
; MouseBtn controls buttons as follows:
;       0 = no buttons pressed
;       1 = Centre button pressed or clicked
;       2 = Right button pressed or clicked
;       4 = Left button pressed or clicked
;       8 = Single click (auto press and release)
;       16= Double click (auto press and release twice in quick succession)

; Note that Left/Right may be swapped by Windows' mouse facilities.

#define MousePosPH      0x0fb   ; Requests mouse positions to PH
#define MousePosDis     0x0fc   ; Requests mouse positions to Displays

; The EPICMOUS program will send Mouse positions (X,Y) as a pair of 16-bit
; values to the named PH or Display (for Display, you need 2 4- or 5-digit
; displays, numbered consecutively, NOT 0 and 1, as 0 means 'stop'!).
; Turn this back off with PH or Display number set to 0.
; Note that only a PH or Display will be used. If you want both you must
; use a PH and SetDisplay from that in the EPL.

; For FS98, a more sophisticated method of using the Mouse is provided, which
; allows tailoring to each FS98 aircraft panel without needing different EPL
; control programs for each.
;   This is accomplished by making the EPICINFO Gauge set the Scaling and
; set up to 63 pairs of (x,y) coordinates, numbered 1-63 (01-3F hex). Then,
; the EPL merely calls up the position number in the MouseBtn command.
; this goes into the top part of the button command value, so:
;     Enque16(MouseBtn,0x070c)
; does a left-button click on position number 7. This will do nothing at all
; (not even click the mouse) if that position is undefined at the time.

;============================
; Miscellaneous specials

;#define ReloadReset     0x0fd
; This isn't used by EPL programs, but is reserved for use
; by the EPIC firmware to inform the VXD that a new EPL
; control program has just been loaded. The normal effect of
; this is to perform an automatic "ResetAllAxes" and then
; reset all buttons. (Note that no versions of the firmware
; before 23rd January 1999 provide this automatic reset feature).

#define EnableJoys      0x0fe

; This specifies which of the 16 possible Win95 EPIC95
; joysticks should be enabled or disabled. By default
; all 16 are enabled (assuming they are all entered into
; "Game Controllers"). Each bit in the parameter represents
; one joystick, with J0 as bit 0x0001, J1 bit 0x0002, etc.
; ReasetAllAxes and ResetRealAxes both reset this to ALL
; joysticks enabled.
;
; Thus ENQUE16(EnableJoys,0xffff) enables all 16 joysticks
; whilst ENQUE16(EnableJoys,0x0001) only enables J0.

; N.B. The value 0xffff cannot be used with any EPIC compiler
; or firmware dated before 26th March 1998. Use ResetRealAxes
; to enable all.

#define SetOptions      0x0ff

; The options word currently has these option bits:
#define LogEnques	0x0001  ; Logs Enque codes and PH/QPs by OutputDebugString
#define ReverseAll	0x0002  ; Reverses joystick assignments: 15->0, 14->1 etc
#define DirectPOV	0x0004  ; Sets POV values without first sending a change

; End of EPICVXD.INC
;============================
